JDBCDatabaseMetaData (HSQLDB 2.3.3 API)
Date: 2015-06-29

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class JDBCDatabaseMetaData

    java.lang.Object
      org.hsqldb.jdbc.JDBCDatabaseMetaData

All Implemented Interfaces:
  DatabaseMetaData, Wrapper

    public class JDBCDatabaseMetaData

extends Object
implements DatabaseMetaData, Wrapper

Comprehensive information about the database as a whole.

This interface is implemented by driver vendors to let users know the capabilities of a Database Management System (DBMS) in combination with the driver based on JDBCTM technology ("JDBC driver") that is used with it. Different relational DBMSs often support different features, implement features in different ways, and use different data types. In addition, a driver may implement a feature on top of what the DBMS offers. Information returned by methods in this interface applies to the capabilities of a particular driver and a particular DBMS working together. Note that as used in this documentation, the term "database" is used generically to refer to both the driver and DBMS.

A user for this interface is commonly a tool that needs to discover how to deal with the underlying DBMS. This is especially true for applications that are intended to be used with more than one DBMS. For example, a tool might use the method `getTypeInfo` to find out what data types can be used in a `CREATE TABLE` statement. Or a user might call the method `supportsCorrelatedSubqueries` to see if it is possible to use a correlated subquery or `supportsBatchUpdates` to see if it is possible to use batch updates.

Some `DatabaseMetaData` methods return lists of information in the form of `ResultSet` objects. Regular `ResultSet` methods, such as `getString` and `getInt`, can be used to retrieve the data from these `ResultSet` objects. If a given form of metadata is not available, an empty `ResultSet` will be returned. Additional columns beyond the columns defined to be returned by the `ResultSet` object for a given method can be defined by the JDBC driver vendor and must be accessed by their column label.

Some `DatabaseMetaData` methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to `null`, that argument's criterion will be dropped from the search.

A method that gets information about a feature that the driver does not support will throw an `SQLException`. In the case of methods that return a `ResultSet` object, either a `ResultSet` object (which may be empty) is returned or an `SQLException` is thrown.

### HSQLDB-Specific Information:

#### Metadata Table Production

Starting with HSQLDB 1.7.2, the metadata table (a.k.a system table) production implementation provided in the default build filters metadata based on each SQL session user's access rights which in turn lifts the pre-HSQLDB 1.7.2 restriction that only users with the DBA role ('admin' users in older HSQLDB parlance) could expect trouble-free access to all metadata.

Also starting with HSQLDB 1.7.2, the metadata table production implementation classes are loaded dynamically, using a precedence policy to find and load the richest producer available at runtime. In the event that no better alternative is found, the default minimal (completely restricted) provider is selected. Under this scheme, it is possible for third party packagers to create custom distributions targeted at supporting full (design-time), custom-written (proprietary / micro environment), minimal (production-time) or completely-restricted (space-constrained | device embedded | real-time | hostile environment) metadata table production scenarios. To learn more about this option, interested parties can review the documentation and source code for the `org.hsqldb.dbinfo.DatabaseInformation class`.

Please also note that in addition to the metadata tables produced to directly support this class, starting with HSQLDB 1.7.2, the default build provides many additional tables covering all or most HSQLDB features, such as descriptions of the triggers and aliases defined in the database.

For instance, in the default build, a fairly comprehensive description of each INFORMATION_SCHEMA table and each INFORMATION_SCHEMA table column is included in the REMARKS column of the `getTables(...)` and `getColumns(...)` results, which derive from INFORMATION_SCHEMA.SYSTEM_TABLES and INFORMATION_SCHEMA.SYSTEM_COLUMNS, respectively.

#### Schema Metadata

The SQL SCHEMA concept became fully supported in the HSQLDB 1.8.x series and this fact is reflected in the all subsequent versions of this class.

#### Catalog Metadata

Starting with HSQLDB 2.0, SQL standards compliance up to SQL:2008 and beyond is a major theme which is reflected in the provision of the majority of the standard-defined full-name INFORMATION_SCHEMA views.

However, just as CATALOG semantics and handling are still considered to be implementation defined by the most recent SQL standard (SQL:2008), so is the HSQLDB CATALOG concept still in the process of being defined and refined in HSQLDB 2.x. and beyond.

Previous to HSQLDB 2.x, there were, at various points in time, experimental features provided to turn on pseudo catalog (and before that, pseudo-schema) reporting in the system tables, using the database properties 'hsqldb.catalogs' and 'hsqldb.schemas', respectively.

However, once the engine fully supported the SQL SCHEMA concept, the experimental 'hsqldb.schemas' * database property was retired.

Similarly, starting with HSQLDB 2.x, the 'hsqldb.catalogs' database property has been retired and replaced with the convention that, from the perspective of SQL identification, an HSQLDB JDBC URL connects to a single HSQLDB database instance which consists of a single, default CATALOG named PUBLIC in which each SCHEMA instance of the database resides. The name of this catalog can be changed with the ALTER CATALOG RENAME TO statement. As of version 2.1.0, HSQLDB supports qualification by the containing CATALOG of database objects at the syntactic level, but does not yet support operations such as opening, manipulating or querying against multiple database catalogs within a single session, not even in a one-at-a-time fashion.

#### Index Metadata

It must still be noted that as of the most recent release, HSQLDB continues to ignore the `approximate` argument of `getIndexInfo()` which continues to be simply indicative of absence of a fully statistics-driven cost-based SQL plan optimization facility. When, such a facility is implemented, corresponding improvements to `getIndexInfo` will be provided.

#### Notes for developers extending metadata table production

Note that in the absence of an ORDER BY clause, queries against the metadata tables that directly support this class are expected to return rows in JDBC contract order. The reason for this is that results typically come back much faster when no "ORDER BY" clause is used.

As such, when adding, extending or replacing a JDBC database metadata table production routine, developers need to be aware of this fact and either add the contract "ORDER BY" clause to the driving SQL or, when possible, preferably maintain rows in the contract order by correctly coding the primary index definition in the table producer class.

JRE 1.1.x Notes:

In general, JDBC 2 support requires Java 1.2 and above, and JDBC3 requires Java 1.4 and above. In HSQLDB, support for methods introduced in different versions of JDBC depends on the JDK version used for compiling and building HSQLDB.

Since 1.7.0, it is possible to build the product so that all JDBC 2 methods can be called while executing under the version 1.1.x Java Runtime EnvironmentTM. However, some of these method calls require `int` values that are defined only in the JDBC 2 or greater version of the `ResultSet` interface. For this reason, when the product is compiled under JDK 1.1.x, these values are defined in `JDBCResultSet`.

In a JRE 1.1.x environment, calling JDBC 2 methods that take or return the JDBC2-only `ResultSet` values can be achieved by referring to them in parameter specifications and return value comparisons, respectively, as follows:

     JDBCResultSet.FETCH_FORWARD
     JDBCResultSet.TYPE_FORWARD_ONLY
     JDBCResultSet.TYPE_SCROLL_INSENSITIVE
     JDBCResultSet.CONCUR_READ_ONLY
     // etc

However, please note that code written in such a manner will not be compatible for use with other JDBC 2 drivers, since they expect and use `ResultSet`, rather than `JDBCResultSet`. Also note, this feature is offered solely as a convenience to developers who must work under JDK 1.1.x due to operating constraints, yet wish to use some of the more advanced features available under the JDBC 2 specification.

(fredt@users)
(boucherb@users)

Author:
  Campbell Burnet (boucherb@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
See Also:
  `DatabaseInformation`, `DatabaseInformationMain`, `DatabaseInformationFull`

Field Summary
`static int` | `JDBC_MAJOR`

Fields inherited from interface java.sql.DatabaseMetaData
`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

Method Summary
`boolean` | `allProceduresAreCallable()` Retrieves whether the current user can call all the procedures returned by the method `getProcedures`.
`boolean` | `allTablesAreSelectable()` Retrieves whether the current user can use all the tables returned by the method `getTables` in a `SELECT` statement.
`boolean` | `autoCommitFailureClosesAllResultSets()` Retrieves whether a `SQLException` while autoCommit is `true` inidcates that all open ResultSets are closed, even ones that are holdable.
`boolean` | `dataDefinitionCausesTransactionCommit()` Retrieves whether a data definition statement within a transaction forces the transaction to commit.
`boolean` | `dataDefinitionIgnoredInTransactions()` Retrieves whether this database ignores a data definition statement within a transaction.
`boolean` | `deletesAreDetected(int type)` Retrieves whether or not a visible row delete can be detected by calling the method `ResultSet.rowDeleted`.
`boolean` | `doesMaxRowSizeIncludeBlobs()` Retrieves whether the return value for the method `getMaxRowSize` includes the SQL data types `LONGVARCHAR` and `LONGVARBINARY`.
`boolean` | `generatedKeyAlwaysReturned()` Retrieves whether a generated key will always be returned if the column name(s) or index(es) specified for the auto generated key column(s) are valid and the statement succeeds.
`ResultSet` | `getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern)` Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.
`ResultSet` | `getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)` Retrieves a description of a table's optimal set of columns that uniquely identifies a row.
`ResultSet` | `getCatalogs()` Retrieves the catalog names available in this database.
`String` | `getCatalogSeparator()` Retrieves the `String` that this database uses as the separator between a catalog and table name.
`String` | `getCatalogTerm()` Retrieves the database vendor's preferred term for "catalog".
`ResultSet` | `getClientInfoProperties()` Retrieves a list of the client info properties that the driver supports.
`ResultSet` | `getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern)` Retrieves a description of the access rights for a table's columns.
`ResultSet` | `getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Retrieves a description of table columns available in the specified catalog.
`Connection` | `getConnection()` Retrieves the connection that produced this metadata object.
`ResultSet` | `getCrossReference(String parentCatalog, String parentSchema, String parentTable, String foreignCatalog, String foreignSchema, String foreignTable)` (JDBC4 clarification:) Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key or the columns representing a unique constraint of the parent table (could be the same or a different table).
`int` | `getDatabaseMajorVersion()` Retrieves the major version number of the underlying database.
`int` | `getDatabaseMinorVersion()` Retrieves the minor version number of the underlying database.
`String` | `getDatabaseProductName()` Retrieves the name of this database product.
`String` | `getDatabaseProductVersion()` Retrieves the version number of this database product.
`int` | `getDefaultTransactionIsolation()` Retrieves this database's default transaction isolation level.
`int` | `getDriverMajorVersion()` Retrieves this JDBC driver's major version number.
`int` | `getDriverMinorVersion()` Retrieves this JDBC driver's minor version number.
`String` | `getDriverName()` Retrieves the name of this JDBC driver.
`String` | `getDriverVersion()` Retrieves the version number of this JDBC driver as a `String`.
`ResultSet` | `getExportedKeys(String catalog, String schema, String table)` Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table).
`String` | `getExtraNameCharacters()` Retrieves all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`ResultSet` | `getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern)` Retrieves a description of the given catalog's system or user function parameters and return type.
`ResultSet` | `getFunctions(String catalog, String schemaPattern, String functionNamePattern)` Retrieves a description of the JDBC 4.1[ system and ]user functions available in the given catalog.
`String` | `getIdentifierQuoteString()` Retrieves the string used to quote SQL identifiers.
`ResultSet` | `getImportedKeys(String catalog, String schema, String table)` Retrieves a description of the primary key columns that are referenced by the given table's foreign key columns (the primary keys imported by a table).
`ResultSet` | `getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)` Retrieves a description of the given table's indices and statistics.
`int` | `getJDBCMajorVersion()` Retrieves the major JDBC version number for this driver.
`int` | `getJDBCMinorVersion()` Retrieves the minor JDBC version number for this driver.
`int` | `getMaxBinaryLiteralLength()` Retrieves the maximum number of hex characters this database allows in an inline binary literal.
`int` | `getMaxCatalogNameLength()` Retrieves the maximum number of characters that this database allows in a catalog name.
`int` | `getMaxCharLiteralLength()` Retrieves the maximum number of characters this database allows for a character literal.
`int` | `getMaxColumnNameLength()` Retrieves the maximum number of characters this database allows for a column name.
`int` | `getMaxColumnsInGroupBy()` Retrieves the maximum number of columns this database allows in a `GROUP BY` clause.
`int` | `getMaxColumnsInIndex()` Retrieves the maximum number of columns this database allows in an index.
`int` | `getMaxColumnsInOrderBy()` Retrieves the maximum number of columns this database allows in an `ORDER BY` clause.
`int` | `getMaxColumnsInSelect()` Retrieves the maximum number of columns this database allows in a `SELECT` list.
`int` | `getMaxColumnsInTable()` Retrieves the maximum number of columns this database allows in a table.
`int` | `getMaxConnections()` Retrieves the maximum number of concurrent connections to this database that are possible.
`int` | `getMaxCursorNameLength()` Retrieves the maximum number of characters that this database allows in a cursor name.
`int` | `getMaxIndexLength()` Retrieves the maximum number of bytes this database allows for an index, including all of the parts of the index.
`int` | `getMaxProcedureNameLength()` Retrieves the maximum number of characters that this database allows in a procedure name.
`int` | `getMaxRowSize()` Retrieves the maximum number of bytes this database allows in a single row.
`int` | `getMaxSchemaNameLength()` Retrieves the maximum number of characters that this database allows in a schema name.
`int` | `getMaxStatementLength()` Retrieves the maximum number of characters this database allows in an SQL statement.
`int` | `getMaxStatements()` Retrieves the maximum number of active statements to this database that can be open at the same time.
`int` | `getMaxTableNameLength()` Retrieves the maximum number of characters this database allows in a table name.
`int` | `getMaxTablesInSelect()` Retrieves the maximum number of tables this database allows in a `SELECT` statement.
`int` | `getMaxUserNameLength()` Retrieves the maximum number of characters this database allows in a user name.
`String` | `getNumericFunctions()` Retrieves a comma-separated list of math functions available with this database.
`ResultSet` | `getPrimaryKeys(String catalog, String schema, String table)` Retrieves a description of the given table's primary key columns.
`ResultSet` | `getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)` Retrieves a description of the given catalog's stored procedure parameter and result columns.
`ResultSet` | `getProcedures(String catalog, String schemaPattern, String procedureNamePattern)` Retrieves a description of the stored procedures available in the given catalog.
`String` | `getProcedureTerm()` Retrieves the database vendor's preferred term for "procedure".
`ResultSet` | `getPseudoColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Retrieves a description of the pseudo or hidden columns available in a given table within the specified catalog and schema.
`int` | `getResultSetHoldability()` (JDBC4 clarification:) Retrieves this database's default holdability for `ResultSet` objects.
`RowIdLifetime` | `getRowIdLifetime()` Indicates whether or not this data source supports the SQL `ROWID` type, and if so the lifetime for which a `RowId` object remains valid.
`ResultSet` | `getSchemas()` Retrieves the schema names available in this database.
`ResultSet` | `getSchemas(String catalog, String schemaPattern)` Retrieves the schema names available in this database.
`String` | `getSchemaTerm()` Retrieves the database vendor's preferred term for "schema".
`String` | `getSearchStringEscape()` Retrieves the string that can be used to escape wildcard characters.
`String` | `getSQLKeywords()` Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL:2003 keywords.
`int` | `getSQLStateType()` (JDBC4 modified:) Indicates whether the SQLSTATE returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL:2003.
`String` | `getStringFunctions()` Retrieves a comma-separated list of string functions available with this database.
`ResultSet` | `getSuperTables(String catalog, String schemaPattern, String tableNamePattern)` Retrieves a description of the table hierarchies defined in a particular schema in this database.
`ResultSet` | `getSuperTypes(String catalog, String schemaPattern, String typeNamePattern)` Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
`String` | `getSystemFunctions()` Retrieves a comma-separated list of system functions available with this database.
`ResultSet` | `getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)` Retrieves a description of the access rights for each table available in a catalog.
`ResultSet` | `getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)` Retrieves a description of the tables available in the given catalog.
`ResultSet` | `getTableTypes()` Retrieves the table types available in this database.
`String` | `getTimeDateFunctions()` Retrieves a comma-separated list of the time and date functions available with this database.
`ResultSet` | `getTypeInfo()` Retrieves a description of all the (JDBC4 clarification:) data types supported by this database.
`ResultSet` | `getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)` Retrieves a description of the user-defined types (UDTs) defined in a particular schema.
`String` | `getURL()` Retrieves the URL for this DBMS.
`String` | `getUserName()` Retrieves the user name as known to this database.
`ResultSet` | `getVersionColumns(String catalog, String schema, String table)` Retrieves a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean` | `insertsAreDetected(int type)` Retrieves whether or not a visible row insert can be detected by calling the method `ResultSet.rowInserted`.
`boolean` | `isCatalogAtStart()` Retrieves whether a catalog appears at the start of a fully qualified table name.
`boolean` | `isReadOnly()` Retrieves whether this database is in read-only mode.
`boolean` | `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`boolean` | `locatorsUpdateCopy()` Indicates whether updates made to a LOB are made on a copy or directly to the LOB.
`boolean` | `nullPlusNonNullIsNull()` Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.
`boolean` | `nullsAreSortedAtEnd()` Retrieves whether `NULL` values are sorted at the end regardless of sort order.
`boolean` | `nullsAreSortedAtStart()` Retrieves whether `NULL` values are sorted at the start regardless of sort order.
`boolean` | `nullsAreSortedHigh()` Retrieves whether `NULL` values are sorted high.
`boolean` | `nullsAreSortedLow()` Retrieves whether `NULL` values are sorted low.
`boolean` | `othersDeletesAreVisible(int type)` Retrieves whether deletes made by others are visible.
`boolean` | `othersInsertsAreVisible(int type)` Retrieves whether inserts made by others are visible.
`boolean` | `othersUpdatesAreVisible(int type)` Retrieves whether updates made by others are visible.
`boolean` | `ownDeletesAreVisible(int type)` Retrieves whether a result set's own deletes are visible.
`boolean` | `ownInsertsAreVisible(int type)` Retrieves whether a result set's own inserts are visible.
`boolean` | `ownUpdatesAreVisible(int type)` Retrieves whether for the given type of `ResultSet` object, the result set's own updates are visible.
`boolean` | `storesLowerCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in lower case.
`boolean` | `storesLowerCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in lower case.
`boolean` | `storesMixedCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in mixed case.
`boolean` | `storesMixedCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in mixed case.
`boolean` | `storesUpperCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in upper case.
`boolean` | `storesUpperCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in upper case.
`boolean` | `supportsAlterTableWithAddColumn()` Retrieves whether this database supports `ALTER TABLE` with add column.
`boolean` | `supportsAlterTableWithDropColumn()` Retrieves whether this database supports `ALTER TABLE` with drop column.
`boolean` | `supportsANSI92EntryLevelSQL()` Retrieves whether this database supports the ANSI92 entry level SQL grammar.
`boolean` | `supportsANSI92FullSQL()` Retrieves whether this database supports the ANSI92 full SQL grammar supported.
`boolean` | `supportsANSI92IntermediateSQL()` Retrieves whether this database supports the ANSI92 intermediate SQL grammar supported.
`boolean` | `supportsBatchUpdates()` Retrieves whether this database supports batch updates.
`boolean` | `supportsCatalogsInDataManipulation()` Retrieves whether a catalog name can be used in a data manipulation statement.
`boolean` | `supportsCatalogsInIndexDefinitions()` Retrieves whether a catalog name can be used in an index definition statement.
`boolean` | `supportsCatalogsInPrivilegeDefinitions()` Retrieves whether a catalog name can be used in a privilege definition statement.
`boolean` | `supportsCatalogsInProcedureCalls()` Retrieves whether a catalog name can be used in a procedure call statement.
`boolean` | `supportsCatalogsInTableDefinitions()` Retrieves whether a catalog name can be used in a table definition statement.
`boolean` | `supportsColumnAliasing()` Retrieves whether this database supports column aliasing.
`boolean` | `supportsConvert()` (JDBC4 clarification:) Retrieves whether this database supports the JDBC scalar function `CONVERT` for the conversion of one JDBC type to another.
`boolean` | `supportsConvert(int fromType, int toType)` (JDBC4 clarification:) Retrieves whether this database supports the JDBC scalar function `CONVERT` for conversions between the JDBC types fromType and toType.
`boolean` | `supportsCoreSQLGrammar()` Retrieves whether this database supports the ODBC Core SQL grammar.
`boolean` | `supportsCorrelatedSubqueries()` Retrieves whether this database supports correlated subqueries.
`boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Retrieves whether this database supports both data definition and data manipulation statements within a transaction.
`boolean` | `supportsDataManipulationTransactionsOnly()` Retrieves whether this database supports only data manipulation statements within a transaction.
`boolean` | `supportsDifferentTableCorrelationNames()` Retrieves whether, when table correlation names are supported, they are restricted to being different from the names of the tables.
`boolean` | `supportsExpressionsInOrderBy()` Retrieves whether this database supports expressions in `ORDER BY` lists.
`boolean` | `supportsExtendedSQLGrammar()` Retrieves whether this database supports the ODBC Extended SQL grammar.
`boolean` | `supportsFullOuterJoins()` Retrieves whether this database supports full nested outer joins.
`boolean` | `supportsGetGeneratedKeys()` Retrieves whether auto-generated keys can be retrieved after a statement has been executed
`boolean` | `supportsGroupBy()` Retrieves whether this database supports some form of `GROUP BY` clause.
`boolean` | `supportsGroupByBeyondSelect()` Retrieves whether this database supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause.
`boolean` | `supportsGroupByUnrelated()` Retrieves whether this database supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause.
`boolean` | `supportsIntegrityEnhancementFacility()` Retrieves whether this database supports the SQL Integrity Enhancement Facility.
`boolean` | `supportsLikeEscapeClause()` Retrieves whether this database supports specifying a `LIKE` escape clause.
`boolean` | `supportsLimitedOuterJoins()` Retrieves whether this database provides limited support for outer joins.
`boolean` | `supportsMinimumSQLGrammar()` Retrieves whether this database supports the ODBC Minimum SQL grammar.
`boolean` | `supportsMixedCaseIdentifiers()` Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMixedCaseQuotedIdentifiers()` Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.
`boolean` | `supportsMultipleOpenResults()` Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.
`boolean` | `supportsMultipleResultSets()` Retrieves whether this database supports getting multiple `ResultSet` objects from a single call to the method `execute`.
`boolean` | `supportsMultipleTransactions()` Retrieves whether this database allows having multiple transactions open at once (on different connections).
`boolean` | `supportsNamedParameters()` Retrieves whether this database supports named parameters to callable statements.
`boolean` | `supportsNonNullableColumns()` Retrieves whether columns in this database may be defined as non-nullable.
`boolean` | `supportsOpenCursorsAcrossCommit()` Retrieves whether this database supports keeping cursors open across commits.
`boolean` | `supportsOpenCursorsAcrossRollback()` Retrieves whether this database supports keeping cursors open across rollbacks.
`boolean` | `supportsOpenStatementsAcrossCommit()` Retrieves whether this database supports keeping statements open across commits.
`boolean` | `supportsOpenStatementsAcrossRollback()` Retrieves whether this database supports keeping statements open across rollbacks.
`boolean` | `supportsOrderByUnrelated()` Retrieves whether this database supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause.
`boolean` | `supportsOuterJoins()` Retrieves whether this database supports some form of outer join.
`boolean` | `supportsPositionedDelete()` Retrieves whether this database supports positioned `DELETE` statements.
`boolean` | `supportsPositionedUpdate()` Retrieves whether this database supports positioned `UPDATE` statements.
`boolean` | `supportsResultSetConcurrency(int type, int concurrency)` Retrieves whether this database supports the given concurrency type in combination with the given result set type.
`boolean` | `supportsResultSetHoldability(int holdability)` Retrieves whether this database supports the given result set holdability.
`boolean` | `supportsResultSetType(int type)` Retrieves whether this database supports the given result set type.
`boolean` | `supportsSavepoints()` Retrieves whether this database supports savepoints.
`boolean` | `supportsSchemasInDataManipulation()` Retrieves whether a schema name can be used in a data manipulation statement.
`boolean` | `supportsSchemasInIndexDefinitions()` Retrieves whether a schema name can be used in an index definition statement.
`boolean` | `supportsSchemasInPrivilegeDefinitions()` Retrieves whether a schema name can be used in a privilege definition statement.
`boolean` | `supportsSchemasInProcedureCalls()` Retrieves whether a schema name can be used in a procedure call statement.
`boolean` | `supportsSchemasInTableDefinitions()` Retrieves whether a schema name can be used in a table definition statement.
`boolean` | `supportsSelectForUpdate()` Retrieves whether this database supports `SELECT FOR UPDATE` statements.
`boolean` | `supportsStatementPooling()` Retrieves whether this database supports statement pooling.
`boolean` | `supportsStoredFunctionsUsingCallSyntax()` Retrieves whether this database supports invoking user-defined or vendor functions using the stored procedure escape syntax.
`boolean` | `supportsStoredProcedures()` Retrieves whether this database supports stored procedure calls that use the stored procedure escape syntax.
`boolean` | `supportsSubqueriesInComparisons()` Retrieves whether this database supports subqueries in comparison expressions.
`boolean` | `supportsSubqueriesInExists()` Retrieves whether this database supports subqueries in `EXISTS` expressions.
`boolean` | `supportsSubqueriesInIns()` (JDBC4 correction:) Retrieves whether this database supports subqueries in `IN` expressions.
`boolean` | `supportsSubqueriesInQuantifieds()` Retrieves whether this database supports subqueries in quantified expressions.
`boolean` | `supportsTableCorrelationNames()` Retrieves whether this database supports table correlation names.
`boolean` | `supportsTransactionIsolationLevel(int level)` Retrieves whether this database supports the given transaction isolation level.
`boolean` | `supportsTransactions()` Retrieves whether this database supports transactions.
`boolean` | `supportsUnion()` Retrieves whether this database supports SQL `UNION`.
`boolean` | `supportsUnionAll()` Retrieves whether this database supports SQL `UNION ALL`.
`
`<T> T`
` | `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.
`boolean` | `updatesAreDetected(int type)` Retrieves whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
`boolean` | `usesLocalFilePerTable()` Retrieves whether this database uses a file for each table.
`boolean` | `usesLocalFiles()` Retrieves whether this database stores tables in a local file.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### JDBC_MAJOR

    public static final int JDBC_MAJOR

See Also:
  Constant Field Values

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws SQLException

  Retrieves whether the current user can call all the procedures returned by the method `getProcedures`.

  ### HSQLDB-Specific Information:

  This method always returns `true because the listed procedures are those which the current user can use`.

  Specified by:
    `allProceduresAreCallable` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws SQLException

  Retrieves whether the current user can use all the tables returned by the method `getTables` in a `SELECT` statement.

  ### HSQLDB-Specific Information:

  HSQLDB always reports `true`.

  The `getTables` call returns the list of tables to which the invoking user has some access rights.

  Specified by:
    `allTablesAreSelectable` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getURL

    public String getURL()
                  throws SQLException

  Retrieves the URL for this DBMS.

  Specified by:
    `getURL` in interface `DatabaseMetaData`
  Returns:
    the URL for this DBMS or `null` if it cannot be generated
  Throws:
    `SQLException` - if a database access error occurs

### getUserName

    public String getUserName()
                       throws SQLException

  Retrieves the user name as known to this database.

  Specified by:
    `getUserName` in interface `DatabaseMetaData`
  Returns:
    the database user name
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

  Retrieves whether this database is in read-only mode.

  ### HSQLDB-Specific Information:

  This makes an SQL call to the isReadOnlyDatabase function which provides correct determination of the read-only status for both local and remote database instances.

  Specified by:
    `isReadOnly` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws SQLException

  Retrieves whether `NULL` values are sorted high. Sorted high means that `NULL` values sort higher than any other value in a domain. In an ascending order, if this method returns `true`, `NULL` values will appear at the end. By contrast, the method `nullsAreSortedAtEnd` indicates whether `NULL` values are sorted at the end regardless of sort order.

  ### HSQLDB-Specific Information:

  By default HSQLDB sorts null at start and this method returns `false`. But a different value is returned if `sql.nulls_first` or `sql.nulls_lasst` properties have a non-default value.

  Specified by:
    `nullsAreSortedHigh` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws SQLException

  Retrieves whether `NULL` values are sorted low. Sorted low means that `NULL` values sort lower than any other value in a domain. In an ascending order, if this method returns `true`, `NULL` values will appear at the beginning. By contrast, the method `nullsAreSortedAtStart` indicates whether `NULL` values are sorted at the beginning regardless of sort order.

  ### HSQLDB-Specific Information:

  By default HSQLDB sorts null at start and this method returns `false`. But a different value is returned if `sql.nulls_first` or `sql.nulls_lasst` properties have a non-default value.

  Specified by:
    `nullsAreSortedLow` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws SQLException

  Retrieves whether `NULL` values are sorted at the start regardless of sort order.

  ### HSQLDB-Specific Information:

  By default HSQLDB sorts null at start and this method returns `true`. But a different value is returned if `sql.nulls_first` or `sql.nulls_lasst` properties have a non-default value.

  Use NULLS LAST in the ORDER BY clause to sort null at the end.

  Specified by:
    `nullsAreSortedAtStart` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws SQLException

  Retrieves whether `NULL` values are sorted at the end regardless of sort order.

  ### HSQLDB-Specific Information:

  By default HSQLDB sorts null at start and this method returns `false`. But a different value is returned if `sql.nulls_first` or `sql.nulls_lasst` properties have a non-default value.

  Use NULLS LAST in the ORDER BY clause to sort null at the end.

  Specified by:
    `nullsAreSortedAtEnd` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductName

    public String getDatabaseProductName()
                                  throws SQLException

  Retrieves the name of this database product.

  ### HSQLDB-Specific Information:

  Returns the name of the HSQLDB engine.

  Specified by:
    `getDatabaseProductName` in interface `DatabaseMetaData`
  Returns:
    database product name
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductVersion

    public String getDatabaseProductVersion()
                                     throws SQLException

  Retrieves the version number of this database product.

  ### HSQLDB-Specific Information:

  Returns the full version string.

  Specified by:
    `getDatabaseProductVersion` in interface `DatabaseMetaData`
  Returns:
    database version number
  Throws:
    `SQLException` - if a database access error occurs

### getDriverName

    public String getDriverName()
                         throws SQLException

  Retrieves the name of this JDBC driver.

  Specified by:
    `getDriverName` in interface `DatabaseMetaData`
  Returns:
    JDBC driver name
  Throws:
    `SQLException` - if a database access error occurs

### getDriverVersion

    public String getDriverVersion()
                            throws SQLException

  Retrieves the version number of this JDBC driver as a `String`.

  Specified by:
    `getDriverVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver version
  Throws:
    `SQLException` - if a database access error occurs

### getDriverMajorVersion

    public int getDriverMajorVersion()

  Retrieves this JDBC driver's major version number.

  Specified by:
    `getDriverMajorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  Retrieves this JDBC driver's minor version number.

  Specified by:
    `getDriverMinorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC driver minor version number

### usesLocalFiles

    public boolean usesLocalFiles()
                           throws SQLException

  Retrieves whether this database stores tables in a local file.

  ### HSQLDB-Specific Information:

  From HSQLDB 1.7.2 it is assumed that this refers to data being stored by the JDBC client. This method always returns false.

  Specified by:
    `usesLocalFiles` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws SQLException

  Retrieves whether this database uses a file for each table.

  ### HSQLDB-Specific Information:

  HSQLDB does not use a file for each table. This method always returns `false`.

  Specified by:
    `usesLocalFilePerTable` in interface `DatabaseMetaData`
  Returns:
    `true` if this database uses a local file for each table; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `supportsMixedCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in upper case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `true`.

  Specified by:
    `storesUpperCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in lower case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesLowerCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws SQLException

  Retrieves whether this database treats mixed case unquoted SQL identifiers as case insensitive and stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesMixedCaseIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case sensitive and as a result stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `true`.

  Specified by:
    `supportsMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in upper case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesUpperCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in lower case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesLowerCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws SQLException

  Retrieves whether this database treats mixed case quoted SQL identifiers as case insensitive and stores them in mixed case.

  ### HSQLDB-Specific Information:

  HSQLDB treats unquoted identifiers as case insensitive and stores them in upper case. It treats quoted identifiers as case sensitive and stores them verbatim; this method always returns `false`.

  Specified by:
    `storesMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getIdentifierQuoteString

    public String getIdentifierQuoteString()
                                    throws SQLException

  Retrieves the string used to quote SQL identifiers. This method returns a space " " if identifier quoting is not supported.

  ### HSQLDB-Specific Information:

  HSQLDB uses the standard SQL identifier quote character (the double quote character); this method always returns ".

  Specified by:
    `getIdentifierQuoteString` in interface `DatabaseMetaData`
  Returns:
    the quoting string or a space if quoting is not supported
  Throws:
    `SQLException` - if a database access error occurs

### getSQLKeywords

    public String getSQLKeywords()
                          throws SQLException

  Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL:2003 keywords. (JDBC4 modified => SQL:2003)

  ### HSQLDB-Specific Information:

  The list is empty. However, HSQLDB also supports SQL:2008 keywords and disallows them for database object names without double quoting.

  Specified by:
    `getSQLKeywords` in interface `DatabaseMetaData`
  Returns:
    the list of this database's keywords that are not also SQL:2003 keywords (JDBC4 modified => SQL:2003)
  Throws:
    `SQLException` - if a database access error occurs

### getNumericFunctions

    public String getNumericFunctions()
                               throws SQLException

  Retrieves a comma-separated list of math functions available with this database. These are the Open /Open CLI math function names used in the JDBC function escape clause.

  Specified by:
    `getNumericFunctions` in interface `DatabaseMetaData`
  Returns:
    the list of math functions supported by this database
  Throws:
    `SQLException` - if a database access error occurs

### getStringFunctions

    public String getStringFunctions()
                              throws SQLException

  Retrieves a comma-separated list of string functions available with this database. These are the Open Group CLI string function names used in the JDBC function escape clause.

  Specified by:
    `getStringFunctions` in interface `DatabaseMetaData`
  Returns:
    the list of string functions supported by this database
  Throws:
    `SQLException` - if a database access error occurs

### getSystemFunctions

    public String getSystemFunctions()
                              throws SQLException

  Retrieves a comma-separated list of system functions available with this database. These are the Open Group CLI system function names used in the JDBC function escape clause.

  Specified by:
    `getSystemFunctions` in interface `DatabaseMetaData`
  Returns:
    a list of system functions supported by this database
  Throws:
    `SQLException` - if a database access error occurs

### getTimeDateFunctions

    public String getTimeDateFunctions()
                                throws SQLException

  Retrieves a comma-separated list of the time and date functions available with this database.

  Specified by:
    `getTimeDateFunctions` in interface `DatabaseMetaData`
  Returns:
    the list of time and date functions supported by this database
  Throws:
    `SQLException` - if a database access error occurs

### getSearchStringEscape

    public String getSearchStringEscape()
                                 throws SQLException

  Retrieves the string that can be used to escape wildcard characters. This is the string that can be used to escape '_' or '%' in the catalog search parameters that are a pattern (and therefore use one of the wildcard characters).

  The '_' character represents any single character; the '%' character represents any sequence of zero or more characters.

  ### HSQLDB-Specific Information:

  HSQLDB uses the "\" character to escape wildcard characters.

  Specified by:
    `getSearchStringEscape` in interface `DatabaseMetaData`
  Returns:
    the string used to escape wildcard characters
  Throws:
    `SQLException` - if a database access error occurs

### getExtraNameCharacters

    public String getExtraNameCharacters()
                                  throws SQLException

  Retrieves all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).

  ### HSQLDB-Specific Information:

  By default HSQLDB does not support using any "extra" characters in unquoted identifier names; this method always returns the empty String.

  Specified by:
    `getExtraNameCharacters` in interface `DatabaseMetaData`
  Returns:
    the string containing the extra characters
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws SQLException

  Retrieves whether this database supports `ALTER TABLE` with add column.

  ### HSQLDB-Specific Information:

  From 1.7.0, HSQLDB supports this type of `ALTER TABLE` statement; this method always returns `true`.

  Specified by:
    `supportsAlterTableWithAddColumn` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws SQLException

  Retrieves whether this database supports `ALTER TABLE` with drop column.

  ### HSQLDB-Specific Information:

  From 1.7.0, HSQLDB supports this type of `ALTER TABLE` statement; this method always returns `true`.

  Specified by:
    `supportsAlterTableWithDropColumn` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws SQLException

  Retrieves whether this database supports column aliasing.

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required.

  ### HSQLDB-Specific Information:

  HSQLDB supports column aliasing; this method always returns `true`.

  Specified by:
    `supportsColumnAliasing` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws SQLException

  Retrieves whether this database supports concatenations between `NULL` and non-`NULL` values being `NULL`.

  ### HSQLDB-Specific Information:

  By default HSQLDB returns NULL when NULL and non-NULL values are concatenated. By default this method returns `false`. But a different value is returned if the `sql.concat_nulls` property has a non-default value.

  Specified by:
    `nullPlusNonNullIsNull` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert()
                            throws SQLException

  (JDBC4 clarification:) Retrieves whether this database supports the JDBC scalar function `CONVERT` for the conversion of one JDBC type to another. The JDBC types are the generic SQL data types defined in `java.sql.Types`.

  ### HSQLDB-Specific Information:

  HSQLDB supports conversions; this method always returns `true`.

  Specified by:
    `supportsConvert` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws SQLException

  (JDBC4 clarification:) Retrieves whether this database supports the JDBC scalar function `CONVERT` for conversions between the JDBC types fromType and toType. The JDBC types are the generic SQL data types defined in `java.sql.Types`.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports conversion according to SQL standards. In addition, it supports conversion between values of BOOLEAN and BIT types.

  Specified by:
    `supportsConvert` in interface `DatabaseMetaData`
  Parameters:
    `fromType` - the type to convert from; one of the type codes from the class `java.sql.Types`
    `toType` - the type to convert to; one of the type codes from the class `java.sql.Types`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Types`

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws SQLException

  Retrieves whether this database supports table correlation names.

  ### HSQLDB-Specific Information:

  HSQLDB supports table correlation names; this method always returns `true`.

  Specified by:
    `supportsTableCorrelationNames` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws SQLException

  Retrieves whether, when table correlation names are supported, they are restricted to being different from the names of the tables.

  ### HSQLDB-Specific Information:

  HSQLDB does not require that table correlation names are different from the names of the tables; this method always returns `false`.

  Specified by:
    `supportsDifferentTableCorrelationNames` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws SQLException

  Retrieves whether this database supports expressions in `ORDER BY` lists.

  ### HSQLDB-Specific Information:

  HSQLDB supports expressions in `ORDER BY` lists; this method always returns `true`.

  Specified by:
    `supportsExpressionsInOrderBy` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws SQLException

  Retrieves whether this database supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using a column that is not in the `SELECT` statement in an `ORDER BY` clause; this method always returns `true`.

  Specified by:
    `supportsOrderByUnrelated` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupBy

    public boolean supportsGroupBy()
                            throws SQLException

  Retrieves whether this database supports some form of `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using the `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupBy` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws SQLException

  Retrieves whether this database supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using a column that is not in the `SELECT` statement in a `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupByUnrelated` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws SQLException

  Retrieves whether this database supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports using columns not included in the `SELECT` statement in a `GROUP BY` clause provided that all of the columns in the `SELECT` statement are included in the `GROUP BY` clause; this method always returns `true`.

  Specified by:
    `supportsGroupByBeyondSelect` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws SQLException

  Retrieves whether this database supports specifying a `LIKE` escape clause.

  ### HSQLDB-Specific Information:

  HSQLDB supports specifying a `LIKE` escape clause; this method always returns `true`.

  Specified by:
    `supportsLikeEscapeClause` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws SQLException

  Retrieves whether this database supports getting multiple `ResultSet` objects from a single call to the method `execute`.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports getting multiple `ResultSet` objects from a single call to the method `execute` of the CallableStatement interface; this method returns `true`.

  Specified by:
    `supportsMultipleResultSets` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws SQLException

  Retrieves whether this database allows having multiple transactions open at once (on different connections).

  ### HSQLDB-Specific Information:

  HSQLDB allows having multiple transactions open at once (on different connections); this method always returns `true`.

  Specified by:
    `supportsMultipleTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws SQLException

  Retrieves whether columns in this database may be defined as non-nullable.

  ### HSQLDB-Specific Information:

  HSQLDB supports the specification of non-nullable columns; this method always returns `true`.

  Specified by:
    `supportsNonNullableColumns` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws SQLException

  Retrieves whether this database supports the ODBC Minimum SQL grammar.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ODBC Minimum SQL grammar; this method always returns `true`.

  Specified by:
    `supportsMinimumSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws SQLException

  Retrieves whether this database supports the ODBC Core SQL grammar.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ODBC Core SQL grammar; this method always returns `true`.

  Specified by:
    `supportsCoreSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws SQLException

  Retrieves whether this database supports the ODBC Extended SQL grammar.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ODBC Extended SQL grammar; this method always returns `true`.

  Specified by:
    `supportsExtendedSQLGrammar` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws SQLException

  Retrieves whether this database supports the ANSI92 entry level SQL grammar.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ANSI92 entry level SQL grammar; this method always returns `true`.

  Specified by:
    `supportsANSI92EntryLevelSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws SQLException

  Retrieves whether this database supports the ANSI92 intermediate SQL grammar supported.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ANSI92 intermediate SQL grammar; this method always returns `true`.

  Specified by:
    `supportsANSI92IntermediateSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws SQLException

  Retrieves whether this database supports the ANSI92 full SQL grammar supported.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports the ANSI92 full SQL grammar. The exceptions, such as support for ASSERTION, are not considered grammer issues. This method always returns `true`.

  Specified by:
    `supportsANSI92FullSQL` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws SQLException

  Retrieves whether this database supports the SQL Integrity Enhancement Facility.

  ### HSQLDB-Specific Information:

  This method always returns `true`.

  Specified by:
    `supportsIntegrityEnhancementFacility` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws SQLException

  Retrieves whether this database supports some form of outer join.

  ### HSQLDB-Specific Information:

  HSQLDB supports outer joins; this method always returns `true`.

  Specified by:
    `supportsOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws SQLException

  Retrieves whether this database supports full nested outer joins.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports full nested outer joins; this method always returns `true`.

  Specified by:
    `supportsFullOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws SQLException

  Retrieves whether this database provides limited support for outer joins. (This will be `true` if the method `supportsFullOuterJoins` returns `true`).

  ### HSQLDB-Specific Information:

  HSQLDB supports the LEFT OUTER join syntax; this method always returns `true`.

  Specified by:
    `supportsLimitedOuterJoins` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getSchemaTerm

    public String getSchemaTerm()
                         throws SQLException

  Retrieves the database vendor's preferred term for "schema".

  ### HSQLDB-Specific Information:

  Starting with 1.8.0, HSQLDB supports schemas.

  Specified by:
    `getSchemaTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term for "schema"
  Throws:
    `SQLException` - if a database access error occurs

### getProcedureTerm

    public String getProcedureTerm()
                            throws SQLException

  Retrieves the database vendor's preferred term for "procedure".

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports declaration of functions or procedures directly in SQL.

  Specified by:
    `getProcedureTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term for "procedure"
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogTerm

    public String getCatalogTerm()
                          throws SQLException

  Retrieves the database vendor's preferred term for "catalog".

  ### HSQLDB-Specific Information:

  HSQLDB uses the standard name CATALOG.

  Specified by:
    `getCatalogTerm` in interface `DatabaseMetaData`
  Returns:
    the vendor term for "catalog"
  Throws:
    `SQLException` - if a database access error occurs

### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws SQLException

  Retrieves whether a catalog appears at the start of a fully qualified table name. If not, the catalog appears at the end.

  ### HSQLDB-Specific Information:

  When allowed, a catalog appears at the start of a fully qualified table name; this method always returns `true`.

  Specified by:
    `isCatalogAtStart` in interface `DatabaseMetaData`
  Returns:
    `true` if the catalog name appears at the beginning of a fully qualified table name; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogSeparator

    public String getCatalogSeparator()
                               throws SQLException

  Retrieves the `String` that this database uses as the separator between a catalog and table name.

  ### HSQLDB-Specific Information:

  When used, a catalog name is separated with period; this method always returns a period

  Specified by:
    `getCatalogSeparator` in interface `DatabaseMetaData`
  Returns:
    the separator string
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws SQLException

  Retrieves whether a schema name can be used in a data manipulation statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports schemas where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsSchemasInDataManipulation` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws SQLException

  Retrieves whether a schema name can be used in a procedure call statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports schemas where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsSchemasInProcedureCalls` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws SQLException

  Retrieves whether a schema name can be used in a table definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports schemas where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsSchemasInTableDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws SQLException

  Retrieves whether a schema name can be used in an index definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports schemas where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsSchemasInIndexDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws SQLException

  Retrieves whether a schema name can be used in a privilege definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports schemas where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsSchemasInPrivilegeDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws SQLException

  Retrieves whether a catalog name can be used in a data manipulation statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports catalog names where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsCatalogsInDataManipulation` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws SQLException

  Retrieves whether a catalog name can be used in a procedure call statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports catalog names where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsCatalogsInProcedureCalls` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws SQLException

  Retrieves whether a catalog name can be used in a table definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports catalog names where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsCatalogsInTableDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws SQLException

  Retrieves whether a catalog name can be used in an index definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports catalog names where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsCatalogsInIndexDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws SQLException

  Retrieves whether a catalog name can be used in a privilege definition statement.

  ### HSQLDB-Specific Information:

  From 2.0, HSQLDB supports catalog names where allowed by the standard; this method always returns `true`.

  Specified by:
    `supportsCatalogsInPrivilegeDefinitions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws SQLException

  Retrieves whether this database supports positioned `DELETE` statements.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports updateable result sets; this method always returns `true`.

  Specified by:
    `supportsPositionedDelete` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws SQLException

  Retrieves whether this database supports positioned `UPDATE` statements.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports updateable result sets; this method always returns `true`.

  Specified by:
    `supportsPositionedUpdate` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws SQLException

  Retrieves whether this database supports `SELECT FOR UPDATE` statements.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports updateable result sets; this method always returns `true`.

  Specified by:
    `supportsSelectForUpdate` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws SQLException

  Retrieves whether this database supports stored procedure calls that use the stored procedure escape syntax.

  ### HSQLDB-Specific Information:

  HSQLDB supports calling public static Java methods in the context of SQL Stored Procedures; this method always returns `true`.

  Specified by:
    `supportsStoredProcedures` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `JDBCParameterMetaData`, `JDBCConnection.prepareCall(java.lang.String)`

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws SQLException

  Retrieves whether this database supports subqueries in comparison expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in comparison expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInComparisons` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws SQLException

  Retrieves whether this database supports subqueries in `EXISTS` expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in `EXISTS` expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInExists` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws SQLException

  (JDBC4 correction:) Retrieves whether this database supports subqueries in `IN` expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in `IN` statements; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInIns` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws SQLException

  Retrieves whether this database supports subqueries in quantified expressions.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported subqueries in quantified expressions; this method always returns `true`.

  Specified by:
    `supportsSubqueriesInQuantifieds` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws SQLException

  Retrieves whether this database supports correlated subqueries.

  ### HSQLDB-Specific Information:

  HSQLDB has always supported correlated subqueries; this method always returns `true`.

  Specified by:
    `supportsCorrelatedSubqueries` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnion

    public boolean supportsUnion()
                          throws SQLException

  Retrieves whether this database supports SQL `UNION`.

  ### HSQLDB-Specific Information:

  HSQLDB supports SQL `UNION`; this method always returns `true`.

  Specified by:
    `supportsUnion` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnionAll

    public boolean supportsUnionAll()
                             throws SQLException

  Retrieves whether this database supports SQL `UNION ALL`.

  ### HSQLDB-Specific Information:

  HSQLDB supports SQL `UNION ALL`; this method always returns `true`.

  Specified by:
    `supportsUnionAll` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws SQLException

  Retrieves whether this database supports keeping cursors open across commits.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 supports keeping cursors open across commits. This method always returns `true`.

  Specified by:
    `supportsOpenCursorsAcrossCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws SQLException

  Retrieves whether this database supports keeping cursors open across rollbacks.

  ### HSQLDB-Specific Information:

  HSQLDB 2.0 closes open cursors at rollback. This method always returns `false`.

  Specified by:
    `supportsOpenCursorsAcrossRollback` in interface `DatabaseMetaData`
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws SQLException

  Retrieves whether this database supports keeping statements open across commits.

  ### HSQLDB-Specific Information:

  HSQLDB supports keeping statements open across commits; this method always returns `true`.

  Specified by:
    `supportsOpenStatementsAcrossCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws SQLException

  Retrieves whether this database supports keeping statements open across rollbacks.

  ### HSQLDB-Specific Information:

  HSQLDB supports keeping statements open across rollbacks; this method always returns `true`.

  Specified by:
    `supportsOpenStatementsAcrossRollback` in interface `DatabaseMetaData`
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws SQLException

  Retrieves the maximum number of hex characters this database allows in an inline binary literal.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxBinaryLiteralLength` in interface `DatabaseMetaData`
  Returns:
    max the maximum length (in hex characters) for a binary literal; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws SQLException

  Retrieves the maximum number of characters this database allows for a character literal.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxCharLiteralLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a character literal; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws SQLException

  Retrieves the maximum number of characters this database allows for a column name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxColumnNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a column name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws SQLException

  Retrieves the maximum number of columns this database allows in a `GROUP BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxColumnsInGroupBy` in interface `DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws SQLException

  Retrieves the maximum number of columns this database allows in an index.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxColumnsInIndex` in interface `DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws SQLException

  Retrieves the maximum number of columns this database allows in an `ORDER BY` clause.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxColumnsInOrderBy` in interface `DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws SQLException

  Retrieves the maximum number of columns this database allows in a `SELECT` list.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxColumnsInSelect` in interface `DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws SQLException

  Retrieves the maximum number of columns this database allows in a table.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxColumnsInTable` in interface `DatabaseMetaData`
  Returns:
    the maximum number of columns allowed; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxConnections

    public int getMaxConnections()
                          throws SQLException

  Retrieves the maximum number of concurrent connections to this database that are possible.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxConnections` in interface `DatabaseMetaData`
  Returns:
    the maximum number of active connections possible at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws SQLException

  Retrieves the maximum number of characters that this database allows in a cursor name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxCursorNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a cursor name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxIndexLength

    public int getMaxIndexLength()
                          throws SQLException

  Retrieves the maximum number of bytes this database allows for an index, including all of the parts of the index.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory and disk availabily; this method always returns `0`.

  Specified by:
    `getMaxIndexLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of bytes allowed; this limit includes the composite of all the constituent parts of the index; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws SQLException

  Retrieves the maximum number of characters that this database allows in a schema name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxSchemaNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a schema name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws SQLException

  Retrieves the maximum number of characters that this database allows in a procedure name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxProcedureNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a procedure name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws SQLException

  Retrieves the maximum number of characters that this database allows in a catalog name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxCatalogNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed in a catalog name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxRowSize

    public int getMaxRowSize()
                      throws SQLException

  Retrieves the maximum number of bytes this database allows in a single row.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory and disk availabily; this method always returns `0`.

  Specified by:
    `getMaxRowSize` in interface `DatabaseMetaData`
  Returns:
    the maximum number of bytes allowed for a row; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws SQLException

  Retrieves whether the return value for the method `getMaxRowSize` includes the SQL data types `LONGVARCHAR` and `LONGVARBINARY`.

  ### HSQLDB-Specific Indormation:

  Including 2.0, `getMaxRowSize()` always returns 0, indicating that the maximum row size is unknown or has no limit. This applies to the above types as well; this method always returns `true`.

  Specified by:
    `doesMaxRowSizeIncludeBlobs` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatementLength

    public int getMaxStatementLength()
                              throws SQLException

  Retrieves the maximum number of characters this database allows in an SQL statement.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxStatementLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for an SQL statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatements

    public int getMaxStatements()
                         throws SQLException

  Retrieves the maximum number of active statements to this database that can be open at the same time.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxStatements` in interface `DatabaseMetaData`
  Returns:
    the maximum number of statements that can be open at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws SQLException

  Retrieves the maximum number of characters this database allows in a table name.

  ### HSQLDB-Specific Information:

  Up to and including 1.8.0.x, HSQLDB did not impose a "known" limit. Th hard limit was the maximum length of a java.lang.String (java.lang.Integer.MAX_VALUE); this method always returned `0`. Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxTableNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a table name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws SQLException

  Retrieves the maximum number of tables this database allows in a `SELECT` statement.

  ### HSQLDB-Specific Information:

  HSQLDB does not impose a "known" limit. The limit is subject to memory availabily; this method always returns `0`.

  Specified by:
    `getMaxTablesInSelect` in interface `DatabaseMetaData`
  Returns:
    the maximum number of tables allowed in a `SELECT` statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws SQLException

  Retrieves the maximum number of characters this database allows in a user name.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB implements the SQL standard, which is 128 for all names.

  Specified by:
    `getMaxUserNameLength` in interface `DatabaseMetaData`
  Returns:
    the maximum number of characters allowed for a user name; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws SQLException

  Retrieves this database's default transaction isolation level. The possible values are defined in `java.sql.Connection`.

  ### HSQLDB-Specific Information

  Default isolation mode in version 2.0 is TRANSACTION_READ_COMMITED.

  Specified by:
    `getDefaultTransactionIsolation` in interface `DatabaseMetaData`
  Returns:
    the default isolation level
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `JDBCConnection`

### supportsTransactions

    public boolean supportsTransactions()
                                 throws SQLException

  Retrieves whether this database supports transactions. If not, invoking the method `commit` is a noop, and the isolation level is `TRANSACTION_NONE`.

  ### HSQLDB-Specific Information:

  HSQLDB supports transactions; this method always returns `true`.

  Specified by:
    `supportsTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if transactions are supported; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws SQLException

  Retrieves whether this database supports the given transaction isolation level.

  ### HSQLDB-Specific Information

  HSQLDB supports all levels.

  Specified by:
    `supportsTransactionIsolationLevel` in interface `DatabaseMetaData`
  Parameters:
    `level` - one of the transaction isolation levels defined in `java.sql.Connection`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `JDBCConnection`

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws SQLException

  Retrieves whether this database supports both data definition and data manipulation statements within a transaction.

  ### HSQLDB-Specific Information:

  HSQLDB does not support a mix of both data definition and data manipulation statements within a transaction. DDL commits the current transaction before proceding; this method always returns `false`.

  Specified by:
    `supportsDataDefinitionAndDataManipulationTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws SQLException

  Retrieves whether this database supports only data manipulation statements within a transaction.

  ### HSQLDB-Specific Information:

  HSQLDB supports only data manipulation statements within a transaction. DDL commits the current transaction before proceeding, while DML does not; this method always returns `true`.

  Specified by:
    `supportsDataManipulationTransactionsOnly` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws SQLException

  Retrieves whether a data definition statement within a transaction forces the transaction to commit.

  ### HSQLDB-Specific Information:

  Including 2.0, a data definition statement within a transaction forces the transaction to commit; this method always returns `true`.

  Specified by:
    `dataDefinitionCausesTransactionCommit` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws SQLException

  Retrieves whether this database ignores a data definition statement within a transaction.

  ### HSQLDB-Specific Information:

  Including 2.0, a data definition statement is not ignored within a transaction. Rather, a data definition statement within a transaction forces the transaction to commit; this method always returns `false`.

  Specified by:
    `dataDefinitionIgnoredInTransactions` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getProcedures

    public ResultSet getProcedures(String catalog,
                                   String schemaPattern,
                                   String procedureNamePattern)
                            throws SQLException

  Retrieves a description of the stored procedures available in the given catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by JDBC 4.1[`PROCEDURE_CAT`,] `PROCEDURE_SCHEM`, `PROCEDURE_NAME` and (new to JDBC4)[`SPECIFIC_ NAME`].

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be `null`)
  2. PROCEDURE_SCHEM String => procedure schema (may be `null`)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use (HSQLDB-specific: NUM_INPUT_PARAMS)
  5. reserved for future use (HSQLDB-specific: NUM_OUTPUT_PARAMS)
  6. reserved for future use (HSQLDB-specific: NUM_RESULT_SETS)
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - (JDBC4 clarification:) Cannot determine if a return value will be returned
     - procedureNoResult - (JDBC4 clarification:) Does not return a return value
     - procedureReturnsResult - (JDBC4 clarification:) Returns a return value
  9. SPECIFIC_NAME String => (JDBC4 new:) The name which uniquely identifies this procedure within its schema.

  A user may not have permissions to execute any of the procedures that are returned by `getProcedures`

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  In version 1.9, the rows returned by this method are based on rows in the INFORMATION_SCHEMA.ROUTINES table.

  Specified by:
    `getProcedures` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
  Returns:
    `ResultSet` - each row is a procedure description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getProcedureColumns

    public ResultSet getProcedureColumns(String catalog,
                                         String schemaPattern,
                                         String procedureNamePattern,
                                         String columnNamePattern)
                                  throws SQLException

  Retrieves a description of the given catalog's stored procedure parameter and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by JDBC 4.1[PROCEDURE_CAT,] PROCEDURE_SCHEM, PROCEDURE_NAME and SPECIFIC_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be `null`)
  2. PROCEDURE_SCHEM String => procedure schema (may be `null`)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in `ResultSet`
  6. DATA_TYPE int => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale - null is returned for data types where SCALE is not applicable.
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL.
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column
  14. COLUMN_DEF String => default value for the column, which should be interpreted as a string when the value is enclosed in single quotes (may be `null`)
      - The string NULL (not enclosed in quotes) - if NULL was specified as the default value
      - TRUNCATE (not enclosed in quotes) - if the specified default value cannot be represented without truncation
      - NULL - if a default value was not specified
  15. SQL_DATA_TYPE int => (JDBC4 new:) Reserved for future use

      HSQLDB-specific: CLI type from SQL 2003 Table 37, tables 6-9 Annex A1, and/or addendums in other documents, such as:
      SQL 2003 Part 9: Management of External Data (SQL/MED) : DATALINK
      SQL 2003 Part 14: XML-Related Specifications (SQL/XML) : XML

  16. SQL_DATETIME_SUB int => (JDBC4 new:) reserved for future use

      HSQLDB-specific: CLI SQL_DATETIME_SUB from SQL 2003 Table 37

  17. CHAR_OCTET_LENGTH int => (JDBC4 new:) the maximum length of binary and character based columns. For any other datatype the returned value is a NULL
  18. ORDINAL_POSITION int => (JDBC4 new:) the ordinal position, starting from 1, for the input and output parameters for a procedure. A value of 0 is returned if this row describes the procedure's return value. JDBC 4.1[For result set columns, it is the ordinal position of the column in the result set starting from 1. If there are multiple result sets, the column ordinal positions are implementation defined.]
  19. IS_NULLABLE String => ISO rules are used to determine the nullability for a column.
      - YES --- if the parameter or result column can include NULLs
      - NO --- if the parameter or result column cannot include NULLs
      - empty string --- if the nullability for the parameter or result column is unknown
  20. SPECIFIC_NAME String => (JDBC4 new:) the name which uniquely identifies this procedure within its schema.

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond (JDBC4 modified:) SPECIFIC_NAME can be defined by the database and must be accessed by their column name.

  (JDBC4 clarification:)

  The PRECISION column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the [declared or implicit maximum] length in characters. For datetime datatypes, this is the [maximum] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. JDBC 4.1 Deleted[0] JDBC 4.1 Added[Null] is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationFull`.

  Specified by:
    `getProcedureColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row describes a stored procedure parameter or column
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTables

    public ResultSet getTables(String catalog,
                               String schemaPattern,
                               String tableNamePattern,
                               String[] types)
                        throws SQLException

  Retrieves a description of the tables available in the given catalog. Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by `TABLE_TYPE`, JDBC 4.1[`TABLE_CAT`,] `TABLE_SCHEM` and `TABLE_NAME`.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table
  6. TYPE_CAT String => the types catalog (may be `null`)
  7. TYPE_SCHEM String => the types schema (may be `null`)
  8. TYPE_NAME String => type name (may be `null`)
  9. SELF_REFERENCING_COL_NAME String => name of the designated "identifier" column of a typed table (may be `null`)
  10. REF_GENERATION String => specifies how values in SELF_REFERENCING_COL_NAME are created. Values are "SYSTEM", "USER", "DERIVED". (may be `null`)

  Note: Some databases may not return information for all tables.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  HSQLDB returns extra information on TEXT tables in the REMARKS column.

  HSQLDB includes the JDBC3 columns TYPE_CAT, TYPE_SCHEM, TYPE_NAME and SELF_REFERENCING_COL_NAME in anticipation of JDBC3 compliant tools.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getTables` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
    `types` - a list of table types, which must be from the list of table types returned from `getTableTypes()`,to include; `null` returns all types
  Returns:
    `ResultSet` - each row is a table description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getSchemas

    public ResultSet getSchemas()
                         throws SQLException

  Retrieves the schema names available in this database. The results are ordered by JDBC 4.1[`TABLE_CATALOG`] and `TABLE_SCHEM`.

  The schema columns are:

  1. TABLE_SCHEM String => schema name
  2. TABLE_CATALOG String => catalog name (may be `null`)

  ### HSQLDB-Specific Information:

  Starting with 1.8.0, the list of schemas is returned.

  Specified by:
    `getSchemas` in interface `DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row is a schema description
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogs

    public ResultSet getCatalogs()
                          throws SQLException

  Retrieves the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getCatalogs` in interface `DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row has a single `String` column that is a catalog name
  Throws:
    `SQLException` - if a database access error occurs

### getTableTypes

    public ResultSet getTableTypes()
                            throws SQLException

  Retrieves the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".

  ### HSQLDB-Specific Information:

  Since 1.7.1, HSQLDB reports: "TABLE", "VIEW" and "GLOBAL TEMPORARY" types. Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getTableTypes` in interface `DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row has a single `String` column that is a table type
  Throws:
    `SQLException` - if a database access error occurs

### getColumns

    public ResultSet getColumns(String catalog,
                                String schemaPattern,
                                String tableNamePattern,
                                String columnNamePattern)
                         throws SQLException

  Retrieves a description of table columns available in the specified catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by JDBC 4.1[`TABLE_CAT`, ]`TABLE_SCHEM`, `TABLE_NAME`, and `ORDINAL_POSITION`.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE int => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  7. COLUMN_SIZE int => column size.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed.
      - columnNoNulls - might not allow `NULL` values
      - columnNullable - definitely allows `NULL` values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be `null`)
  13. COLUMN_DEF String => (JDBC4 clarification:) default value for the column, which should be interpreted as a string when the value is enclosed in quotes (may be `null`)
  14. SQL_DATA_TYPE int => unused

      HSQLDB-specific: CLI type from SQL 2003 Table 37, tables 6-9 Annex A1, and/or addendums in other documents, such as:
      SQL 2003 Part 9: Management of External Data (SQL/MED) : DATALINK
      SQL 2003 Part 14: XML-Related Specifications (SQL/XML) : XML

  15. SQL_DATETIME_SUB int => unused (HSQLDB-specific: SQL 2003 CLI datetime/interval subcode)
  16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int => index of column in table (starting at 1)
  18. IS_NULLABLE String => ISO rules are used to determine the nullability for a column.
      - YES --- if the column can include NULLs
      - NO --- if the column cannot include NULLs
      - empty string --- if the nullability for the column is unknown
  19. JDBC 4.1 Deleted[SCOPE_CATLOG] JDBC 4.1 Added[SCOPE_CATALOG] String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  20. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
  21. SCOPE_TABLE String => table name that this the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
  22. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type, SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)
  23. IS_AUTOINCREMENT String => Indicates whether this column is auto incremented
      - YES --- if the column is auto incremented
      - NO --- if the column is not auto incremented
      - empty string --- if it cannot be determined whether the column is auto incremented
  24. (JDBC 4.1 New:)IS_GENERATEDCOLUMN String => Indicates whether this is a generated column
      - YES --- if this a generated column
      - NO --- if this not a generated column
      - empty string --- if it cannot be determined whether this is a generated column

  (JDBC4 clarification:) The COLUMN_SIZE column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the [declared or implicit maximum] length in characters. For datetime datatypes, this is the [maximum] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. JDBC 4.1 Deleted[0] JDBC 4.1 Added[Null] is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  This feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getColumnPrivileges

    public ResultSet getColumnPrivileges(String catalog,
                                         String schema,
                                         String table,
                                         String columnNamePattern)
                                  throws SQLException

  Retrieves a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilege description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR String => grantor of access (may be `null`)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  This feature is supported by default. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getColumnPrivileges` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row is a column privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTablePrivileges

    public ResultSet getTablePrivileges(String catalog,
                                        String schemaPattern,
                                        String tableNamePattern)
                                 throws SQLException

  Retrieves a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this privilege applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by JDBC 4.1[`TABLE_CAT`,] `TABLE_SCHEM`, `TABLE_NAME`, and `PRIVILEGE`.

  Each privilege description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. GRANTOR String => grantor of access (may be `null`)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getTablePrivileges` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a table privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getBestRowIdentifier

    public ResultSet getBestRowIdentifier(String catalog,
                                          String schema,
                                          String table,
                                          int scope,
                                          boolean nullable)
                                   throws SQLException

  Retrieves a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE int => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale - Null is returned for data types where DECIMAL_DIGITS is not applicable.
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column

  (JDBC4 clarification:)

  The COLUMN_SIZE column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the [declared or implicit maximum] length in characters. For datetime datatypes, this is the [maximum] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. JDBC 4.1 Deleted[0] JDBC 4.1 Added[Null] is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  If the name of a column is defined in the database without double quotes, an all-uppercase name must be specified when calling this method. Otherwise, the name must be specified in the exact case of the column definition in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getBestRowIdentifier` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable.
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getVersionColumns

    public ResultSet getVersionColumns(String catalog,
                                       String schema,
                                       String table)
                                throws SQLException

  Retrieves a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE int => SQL data type from `java.sql.Types`
  4. TYPE_NAME String => Data source-dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale - Null is returned for data types where DECIMAL_DIGITS is not applicable.
  8. PSEUDO_COLUMN short => whether this is pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column

  (JDBC4 clarification:)

  The COLUMN_SIZE column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the [declared or implicit maximum] length in characters. For datetime datatypes, this is the [maximum] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. JDBC 4.1 Deleted[0], JDBC 4.1 Added[Null] is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  HSQLDB does not support version columns. This returns an empty result set.

  Specified by:
    `getVersionColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    a `ResultSet` object in which each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getPrimaryKeys

    public ResultSet getPrimaryKeys(String catalog,
                                    String schema,
                                    String table)
                             throws SQLException

  Retrieves a description of the given table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => (JDBC4 Clarification:) sequence number within primary key( a value of 1 represents the first column of the primary key, a value of 2 would represent the second column within the primary key).
  6. PK_NAME String => primary key name (may be `null`)

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getPrimaryKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getImportedKeys

    public ResultSet getImportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Retrieves a description of the primary key columns that are referenced by the given table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be `null`)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be `null`)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => (JDBC4 clarification) sequence number within a foreign key (a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
  10. UPDATE_RULE short => What happens to a foreign key when the primary key is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => primary key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getImportedKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getExportedKeys

    public ResultSet getExportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be `null`)
  2. PKTABLE_SCHEM String => primary key table schema (may be `null`)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`) being exported (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`) being exported (may be `null`)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => (JDBC4 clarification:) sequence number within foreign key( a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => primary key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getExportedKeys` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in this database
  Returns:
    a `ResultSet` object in which each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getCrossReference

    public ResultSet getCrossReference(String parentCatalog,
                                       String parentSchema,
                                       String parentTable,
                                       String foreignCatalog,
                                       String foreignSchema,
                                       String foreignTable)
                                throws SQLException

  (JDBC4 clarification:) Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key or the columns representing a unique constraint of the parent table (could be the same or a different table). The number of columns returned from the parent table must match the number of columns that make up the foreign key. They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => parent key table catalog (may be `null`)
  2. PKTABLE_SCHEM String => parent key table schema (may be `null`)
  3. PKTABLE_NAME String => parent key table name
  4. PKCOLUMN_NAME String => parent key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be `null`) being exported (may be `null`)
  6. FKTABLE_SCHEM String => foreign key table schema (may be `null`) being exported (may be `null`)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key( a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
  10. UPDATE_RULE short => What happens to foreign key when parent key is updated:
      - importedNoAction - do not allow update of parent key if it has been imported
      - importedKeyCascade - change imported key to agree with parent key update
      - importedKeySetNull - change imported key to `NULL` if its parent key has been updated
      - importedKeySetDefault - change imported key to default values if its parent key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when parent key is deleted.
      - importedKeyNoAction - do not allow delete of parent key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its parent key has been deleted
  12. FK_NAME String => foreign key name (may be `null`)
  13. PK_NAME String => parent key name (may be `null`)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getCrossReference` in interface `DatabaseMetaData`
  Parameters:
    `parentCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `parentSchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
    `parentTable` - the name of the table that exports the key; must match the table name as it is stored in the database
    `foreignCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `foreignSchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
    `foreignTable` - the name of the table that imports the key; must match the table name as it is stored in the database
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`, `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### getTypeInfo

    public ResultSet getTypeInfo()
                          throws SQLException

  Retrieves a description of all the (JDBC4 clarification:) data types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  (JDBC4 clarification:) If the database supports SQL distinct types, then getTypeInfo() will return a single row with a TYPE_NAME of DISTINCT and a DATA_TYPE of Types.DISTINCT. If the database supports SQL structured types, then getTypeInfo() will return a single row with a TYPE_NAME of STRUCT and a DATA_TYPE of Types.STRUCT.

  (JDBC4 clarification:)

  If SQL distinct or structured types are supported, then information on the individual types may be obtained from the getUDTs() method.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE int => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be `null`)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be `null`)
  6. CREATE_PARAMS String => parameters used in creating the type (may be `null`)
  7. NULLABLE short => can you use NULL for this type.
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive.
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned.
  11. FIXED_PREC_SCALE boolean => can it be a money value.
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value.
  13. LOCAL_TYPE_NAME String => localized version of type name (may be `null`)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10

  (JDBC4 clarification:) The PRECISION column represents the maximum column size that the server supports for the given datatype. For numeric data, this is the maximum precision. For character data, this is the [maximum] length in characters. For datetime datatypes, this is the [maximum] length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the [maximum] length in bytes. For the ROWID datatype, this is the length in bytes[, as returned by the implementation-specific java.sql.RowId.getBytes() method]. JDBC 4.1 Deleted[0] JDBC 4.1 Added[Null] is returned for data types where the column size is not applicable.

  ### HSQLDB-Specific Information:

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getTypeInfo` in interface `DatabaseMetaData`
  Returns:
    a `ResultSet` object in which each row is an SQL type description
  Throws:
    `SQLException` - if a database access error occurs

### getIndexInfo

    public ResultSet getIndexInfo(String catalog,
                                  String schema,
                                  String table,
                                  boolean unique,
                                  boolean approximate)
                           throws SQLException

  Retrieves a description of the given table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique. false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be `null`); `null` when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; `null` when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; `null` when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be `null` if sort sequence is not supported; `null` when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be `null`)

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Since 1.7.2, this feature is supported by default. If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getIndexInfo` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schema` - a schema name; must match the schema name as it is stored in this database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `table` - a table name; must match the table name as it is stored in this database
    `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
  Returns:
    `ResultSet` - each row is an index column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `supportsMixedCaseQuotedIdentifiers()`, `storesUpperCaseIdentifiers()`

### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws SQLException

  Retrieves whether this database supports the given result set type.

  Specified by:
    `supportsResultSetType` in interface `DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)
  See Also:
    `JDBCConnection`

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws SQLException

  Retrieves whether this database supports the given concurrency type in combination with the given result set type.

  Specified by:
    `supportsResultSetConcurrency` in interface `DatabaseMetaData`
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)
  See Also:
    `JDBCConnection`

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws SQLException

  Retrieves whether for the given type of `ResultSet` object, the result set's own updates are visible.

  ### HSQLDB-Specific Information:

  Updates to ResultSet rows are not visible after moving from the updated row.

  Specified by:
    `ownUpdatesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if updates are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws SQLException

  Retrieves whether a result set's own deletes are visible.

  ### HSQLDB-Specific Information:

  Rows deleted from the ResultSet are still visible after moving from the deleted row.

  Specified by:
    `ownDeletesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws SQLException

  Retrieves whether a result set's own inserts are visible.

  ### HSQLDB-Specific Information:

  Rows added to a ResultSet are not visible after moving from the insert row; this method always returns `false`.

  Specified by:
    `ownInsertsAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if inserts are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws SQLException

  Retrieves whether updates made by others are visible.

  ### HSQLDB-Specific Information:

  Updates made by other connections or the same connection while the ResultSet is open are not visible in the ResultSet.

  Specified by:
    `othersUpdatesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if updates made by others are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws SQLException

  Retrieves whether deletes made by others are visible.

  ### HSQLDB-Specific Information:

  Deletes made by other connections or the same connection while the ResultSet is open are not visible in the ResultSet.

  Specified by:
    `othersDeletesAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes made by others are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws SQLException

  Retrieves whether inserts made by others are visible.

  ### HSQLDB-Specific Information:

  Inserts made by other connections or the same connection while the ResultSet is open are not visible in the ResultSet.

  Specified by:
    `othersInsertsAreVisible` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if inserts made by others are visible for the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws SQLException

  Retrieves whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.

  ### HSQLDB-Specific Information:

  Updates made to the rows of the ResultSet are not detected by calling the `ResultSet.rowUpdated`.

  Specified by:
    `updatesAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws SQLException

  Retrieves whether or not a visible row delete can be detected by calling the method `ResultSet.rowDeleted`. If the method `deletesAreDetected` returns `false`, it means that deleted rows are removed from the result set.

  ### HSQLDB-Specific Information:

  Deletes made to the rows of the ResultSet are not detected by calling the `ResultSet.rowDeleted`.

  Specified by:
    `deletesAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if deletes are detected by the given result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws SQLException

  Retrieves whether or not a visible row insert can be detected by calling the method `ResultSet.rowInserted`.

  ### HSQLDB-Specific Information:

  Inserts made into the ResultSet are not visible and thus not detected by calling the `ResultSet.rowInserted`.

  Specified by:
    `insertsAreDetected` in interface `DatabaseMetaData`
  Parameters:
    `type` - the `ResultSet` type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Returns:
    `true` if changes are detected by the specified result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws SQLException

  Retrieves whether this database supports batch updates.

  ### HSQLDB-Specific Information:

  HSQLDB supports batch updates; this method always returns `true`.

  Specified by:
    `supportsBatchUpdates` in interface `DatabaseMetaData`
  Returns:
    `true` if this database supports batch upcates; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### getUDTs

    public ResultSet getUDTs(String catalog,
                             String schemaPattern,
                             String typeNamePattern,
                             int[] types)
                      throws SQLException

  Retrieves a description of the user-defined types (UDTs) defined in a particular schema. Schema-specific UDTs may have type `JAVA_OBJECT`, `STRUCT`, or `DISTINCT`.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by `DATA_TYPE`, JDBC 4.1[`TYPE_CAT`,] `TYPE_SCHEM` and `TYPE_NAME`. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String => the type's catalog (may be `null`)
  2. TYPE_SCHEM String => type's schema (may be `null`)
  3. TYPE_NAME String => type name
  4. CLASS_NAME String => Java class name
  5. DATA_TYPE int => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String => explanatory comment on the type
  7. BASE_TYPE short => type code of the source type of a DISTINCT type or the type that implements the user-generated reference type of the SELF_REFERENCING_COLUMN of a structured type as defined in java.sql.Types (`null` if DATA_TYPE is not DISTINCT or not STRUCT with REFERENCE_GENERATION = USER_DEFINED)

  Note: If the driver does not support UDTs, an empty result set is returned.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  Starting with 2.0, DISTICT types are supported and are reported by this method.

  Specified by:
    `getUDTs` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema pattern name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database; may be a fully qualified name
    `types` - a list of user-defined types (JAVA_OBJECT, STRUCT, or DISTINCT) to include; `null` returns all types
  Returns:
    `ResultSet` object in which each row describes a UDT
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)
  See Also:
    `(JDBC4 clarification)`

### getConnection

    public Connection getConnection()
                             throws SQLException

  Retrieves the connection that produced this metadata object.

  Specified by:
    `getConnection` in interface `DatabaseMetaData`
  Returns:
    the connection that produced this metadata object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.2 (JDK 1.1.x developers: read the overview for JDBCDatabaseMetaData)

### supportsSavepoints

    public boolean supportsSavepoints()
                               throws SQLException

  Retrieves whether this database supports savepoints.

  ### HSQLDB-Specific Information:

  Beginning with 1.7.2, this SQL feature is supported through JDBC as well as SQL.

  Specified by:
    `supportsSavepoints` in interface `DatabaseMetaData`
  Returns:
    `true` if savepoints are supported; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsNamedParameters

    public boolean supportsNamedParameters()
                                    throws SQLException

  Retrieves whether this database supports named parameters to callable statements.

  ### HSQLDB-Specific Information:

  Starting with 1.7.2, HSQLDB supports JDBC named parameters to callable statements; this method returns true.

  Specified by:
    `supportsNamedParameters` in interface `DatabaseMetaData`
  Returns:
    `true` if named parameters are supported; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults()
                                        throws SQLException

  Retrieves whether it is possible to have multiple `ResultSet` objects returned from a `CallableStatement` object simultaneously.

  ### HSQLDB-Specific Information:

  HSQLDB supports multiple ResultSet objects returned from a `CallableStatement`; this method always returns `true`.

  Specified by:
    `supportsMultipleOpenResults` in interface `DatabaseMetaData`
  Returns:
    `true` if a `CallableStatement` object can return multiple `ResultSet` objects simultaneously; `false` otherwise
  Throws:
    `SQLException` - if a datanase access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys()
                                     throws SQLException

  Retrieves whether auto-generated keys can be retrieved after a statement has been executed

  ### HSQLDB-Specific Information:

  HSQLDB supports retrieval of autogenerated keys through the JDBC interface; this method always returns `true`.

  Specified by:
    `supportsGetGeneratedKeys` in interface `DatabaseMetaData`
  Returns:
    `true` if auto-generated keys can be retrieved after a statement has executed; `false` otherwise

    (JDBC4 Clarification:)

    If `true` is returned, the JDBC driver must support the returning of auto-generated keys for at least SQL INSERT statements

  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getSuperTypes

    public ResultSet getSuperTypes(String catalog,
                                   String schemaPattern,
                                   String typeNamePattern)
                            throws SQLException

  Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Only the immediate super type sub type relationship is modeled.

  Only supertype information for UDTs matching the catalog, schema, and type name is returned. The type name parameter may be a fully-qualified name. When the UDT name supplied is a fully-qualified name, the catalog and schemaPattern parameters are ignored.

  If a UDT does not have a direct super type, it is not listed here. A row of the `ResultSet` object returned by this method describes the designated UDT and a direct supertype. A row has the following columns:

  1. TYPE_CAT String => the UDT's catalog (may be `null`)
  2. TYPE_SCHEM String => UDT's schema (may be `null`)
  3. TYPE_NAME String => type name of the UDT
  4. SUPERTYPE_CAT String => the direct super type's catalog (may be `null`)
  5. SUPERTYPE_SCHEM String => the direct super type's schema (may be `null`)
  6. SUPERTYPE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  ### HSQLDB-Specific Information:

  HSQLDB supports the SQL Standard. It treats unquoted identifiers as case insensitive in SQL and stores them in upper case; it treats quoted identifiers as case sensitive and stores them verbatim. All JDBCDatabaseMetaData methods perform case-sensitive comparison between name (pattern) arguments and the corresponding identifier values as they are stored in the database. Therefore, care must be taken to specify name arguments precisely (including case) as they are stored in the database.

  From 2.0, this feature is supported by default and return supertypes for DOMAIN and DISTINCT types.

  If the jar is compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is not supported. The default implementation is `DatabaseInformationMain`.

  Specified by:
    `getSuperTypes` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a UDT name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which a row gives information about the designated UDT
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7
  See Also:
    `(JDBC4 clarification)`

### getSuperTables

    public ResultSet getSuperTables(String catalog,
                                    String schemaPattern,
                                    String tableNamePattern)
                             throws SQLException

  Retrieves a description of the table hierarchies defined in a particular schema in this database.

  Only supertable information for tables matching the catalog, schema and table name are returned. The table name parameter may be a fully- qualified name, in which case, the catalog and schemaPattern parameters are ignored. If a table does not have a super table, it is not listed here. Supertables have to be defined in the same catalog and schema as the sub tables. Therefore, the type description does not need to include this information for the supertable.

  Each type description has the following columns:

  1. TABLE_CAT String => the type's catalog (may be `null`)
  2. TABLE_SCHEM String => type's schema (may be `null`)
  3. TABLE_NAME String => type name
  4. SUPERTABLE_NAME String => the direct super type's name

  Note: If the driver does not support type hierarchies, an empty result set is returned.

  ### HSQLDB-Specific Information:

  This method is intended for tables of structured types. From 2.0 this method returns an empty ResultSet. `DatabaseInformationMain`.

  Specified by:
    `getSuperTables` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern; may be a fully-qualified name
  Returns:
    a `ResultSet` object in which each row is a type description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7
  See Also:
    `(JDBC4 clarification)`

### getAttributes

    public ResultSet getAttributes(String catalog,
                                   String schemaPattern,
                                   String typeNamePattern,
                                   String attributeNamePattern)
                            throws SQLException

  Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.

  Descriptions are returned only for attributes of UDTs matching the catalog, schema, type, and attribute name criteria. They are ordered by JDBC 4.1[`TYPE_CAT`, ]`TYPE_SCHEM`, `TYPE_NAME` and `ORDINAL_POSITION`. This description does not contain inherited attributes.

  The `ResultSet` object that is returned has the following columns:

  1. TYPE_CAT String => type catalog (may be `null`)
  2. TYPE_SCHEM String => type schema (may be `null`)
  3. TYPE_NAME String => type name
  4. ATTR_NAME String => attribute name
  5. DATA_TYPE int => attribute type SQL type from java.sql.Types
  6. ATTR_TYPE_NAME String => Data source dependent type name. For a UDT, the type name is fully qualified. For a REF, the type name is fully qualified and represents the target type of the reference type.
  7. ATTR_SIZE int => column size. For char or date types this is the maximum number of characters; for numeric or decimal types this is precision.
  8. DECIMAL_DIGITS int => the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
  9. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  10. NULLABLE int => whether NULL is allowed
      - attributeNoNulls - might not allow NULL values
      - attributeNullable - definitely allows NULL values
      - attributeNullableUnknown - nullability unknown
  11. REMARKS String => comment describing column (may be `null`)
  12. ATTR_DEF String => default value (may be `null`)
  13. SQL_DATA_TYPE int => unused
  14. SQL_DATETIME_SUB int => unused
  15. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  16. ORDINAL_POSITION int => index of JDBC 4.1 correction[the attribute in the UDT] (starting at 1)
  17. IS_NULLABLE String => ISO rules are used to determine the nullability for a column.
      - YES --- if the JDBC 4.1 correction[attribute] can include NULLs
      - NO --- if the JDBC 4.1 correction[attribute] cannot include NULLs
      - empty string --- if the nullability for the JDBC 4.1 correction[attribute] is unknown
  18. SCOPE_CATALOG String => catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  19. SCOPE_SCHEMA String => schema of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
  20. SCOPE_TABLE String => table name that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
  21. SOURCE_DATA_TYPE short => source type of a distinct type or user-generated Ref type,SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)

  ### HSQLDB-Specific Information:

  This method is intended for attributes of structured types. From 2.0 this method returns an empty ResultSet.

  Specified by:
    `getAttributes` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database
    `attributeNamePattern` - an attribute name pattern; must match the attribute name as it is declared in the database
  Returns:
    a `ResultSet` object in which each row is an attribute description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7
  See Also:
    `getSearchStringEscape()`

### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int holdability)
                                         throws SQLException

  Retrieves whether this database supports the given result set holdability.

  ### HSQLDB-Specific Information:

  HSQLDB returns true for both alternatives.

  Specified by:
    `supportsResultSetHoldability` in interface `DatabaseMetaData`
  Parameters:
    `holdability` - one of the following constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7
  See Also:
    `JDBCConnection`

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

  (JDBC4 clarification:) Retrieves this database's default holdability for `ResultSet` objects.

  ### HSQLDB-Specific Information:

  HSQLDB defaults to HOLD_CURSORS_OVER_COMMIT for CONSUR_READ_ONLY ResultSet objects. If the ResultSet concurrency is CONCUR_UPDATABLE, then holdability is is enforced as CLOSE_CURSORS_AT_COMMIT.

  Specified by:
    `getResultSetHoldability` in interface `DatabaseMetaData`
  Returns:
    the default holdability; either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getDatabaseMajorVersion

    public int getDatabaseMajorVersion()
                                throws SQLException

  Retrieves the major version number of the underlying database.

  ### HSQLDB-Specific Information:

  Returns the major version

  Specified by:
    `getDatabaseMajorVersion` in interface `DatabaseMetaData`
  Returns:
    the underlying database's major version
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getDatabaseMinorVersion

    public int getDatabaseMinorVersion()
                                throws SQLException

  Retrieves the minor version number of the underlying database.

  ### HSQLDB-Specific Information:

  This returns the digit after the first point in version.

  Specified by:
    `getDatabaseMinorVersion` in interface `DatabaseMetaData`
  Returns:
    underlying database's minor version
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getJDBCMajorVersion

    public int getJDBCMajorVersion()
                            throws SQLException

  Retrieves the major JDBC version number for this driver.

  ### HSQLDB-Specific Information:

  Specified by:
    `getJDBCMajorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC version major number
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getJDBCMinorVersion

    public int getJDBCMinorVersion()
                            throws SQLException

  Retrieves the minor JDBC version number for this driver.

  ### HSQLDB-Specific Information:

  Specified by:
    `getJDBCMinorVersion` in interface `DatabaseMetaData`
  Returns:
    JDBC version minor number
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getSQLStateType

    public int getSQLStateType()
                        throws SQLException

  (JDBC4 modified:) Indicates whether the SQLSTATE returned by `SQLException.getSQLState` is X/Open (now known as Open Group) SQL CLI or SQL:2003.

  ### HSQLDB-Specific Information:

  HSQLDB returns `sqlStateSQL` under JDBC4 which is equivalent to JDBC3 value of sqlStateSQL99.

  Specified by:
    `getSQLStateType` in interface `DatabaseMetaData`
  Returns:
    the type of SQLSTATE; one of: sqlStateXOpen or sqlStateSQL

    sqlStateSQL is new in JDBC4 and its value is the same as JDBC3 sqlStateSQL99

  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### locatorsUpdateCopy

    public boolean locatorsUpdateCopy()
                               throws SQLException

  Indicates whether updates made to a LOB are made on a copy or directly to the LOB.

  ### HSQLDB-Specific Information:

  Updates to a LOB are made directly. This means the lobs in an updatable ResultSet can be updated and the change is applied when the updateRow() method is applied. Lobs created by calling the Connection methods createClob() and createBlob() can be updated. The lob can then be sent to the database in a PreparedStatement with an UPDATE or INSERT SQL statement.

  Specified by:
    `locatorsUpdateCopy` in interface `DatabaseMetaData`
  Returns:
    `true` if updates are made to a copy of the LOB; `false` if updates are made directly to the LOB
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### supportsStatementPooling

    public boolean supportsStatementPooling()
                                     throws SQLException

  Retrieves whether this database supports statement pooling.

  ### HSQLDB-Specific Information:

  Starting with 2.0, HSQLDB supports statement pooling when built under JDK 1.6+.

  Specified by:
    `supportsStatementPooling` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.4, HSQLDB 1.7

### getRowIdLifetime

    public RowIdLifetime getRowIdLifetime()
                                   throws SQLException

  Indicates whether or not this data source supports the SQL `ROWID` type, and if so the lifetime for which a `RowId` object remains valid.

  The returned int values have the following relationship:

           ROWID_UNSUPPORTED < ROWID_VALID_OTHER < ROWID_VALID_TRANSACTION
               < ROWID_VALID_SESSION < ROWID_VALID_FOREVER

  so conditional logic such as

           if (metadata.getRowIdLifetime() > DatabaseMetaData.ROWID_VALID_TRANSACTION)

  can be used. Valid Forever means valid across all Sessions, and valid for a Session means valid across all its contained Transactions.

  Specified by:
    `getRowIdLifetime` in interface `DatabaseMetaData`
  Returns:
    the status indicating the lifetime of a `RowId`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9

### getSchemas

    public ResultSet getSchemas(String catalog,
                                String schemaPattern)
                         throws SQLException

  Retrieves the schema names available in this database. The results are ordered by JDBC 4.1[`TABLE_CATALOG`] and `TABLE_SCHEM`.

  The schema columns are:

  1. TABLE_SCHEM String => schema name
  2. TABLE_CATALOG String => catalog name (may be `null`)

  Specified by:
    `getSchemas` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database;"" retrieves those without a catalog; null means catalog name should not be used to narrow down the search.
    `schemaPattern` - a schema name; must match the schema name as it is stored in the database; null means schema name should not be used to narrow down the search.
  Returns:
    a `ResultSet` object in which each row is a schema description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9
  See Also:
    `getSearchStringEscape()`

### supportsStoredFunctionsUsingCallSyntax

    public boolean supportsStoredFunctionsUsingCallSyntax()
                                                   throws SQLException

  Retrieves whether this database supports invoking user-defined or vendor functions using the stored procedure escape syntax.

  Specified by:
    `supportsStoredFunctionsUsingCallSyntax` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9

### autoCommitFailureClosesAllResultSets

    public boolean autoCommitFailureClosesAllResultSets()
                                                 throws SQLException

  Retrieves whether a `SQLException` while autoCommit is `true` inidcates that all open ResultSets are closed, even ones that are holdable. When a `SQLException` occurs while autocommit is `true`, it is vendor specific whether the JDBC driver responds with a commit operation, a rollback operation, or by doing neither a commit nor a rollback. A potential result of this difference is in whether or not holdable ResultSets are closed.

  Specified by:
    `autoCommitFailureClosesAllResultSets` in interface `DatabaseMetaData`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9

### getClientInfoProperties

    public ResultSet getClientInfoProperties()
                                      throws SQLException

  Retrieves a list of the client info properties that the driver supports. The result set contains the following columns

  1. NAME String=> The name of the client info property
  2. MAX_LEN int=> The maximum length of the value for the property
  3. DEFAULT_VALUE String=> The default value of the property
  4. DESCRIPTION String=> A description of the property. This will typically contain information as to where this property is stored in the database.

  The `ResultSet` is sorted by the NAME column

  Specified by:
    `getClientInfoProperties` in interface `DatabaseMetaData`
  Returns:
    A `ResultSet` object; each row is a supported client info property

  Throws:
    `SQLException` - if a database access error occurs

  Since:
    JDK 1.6, HSQLDB 1.9

### getFunctions

    public ResultSet getFunctions(String catalog,
                                  String schemaPattern,
                                  String functionNamePattern)
                           throws SQLException

  Retrieves a description of the JDBC 4.1[ system and ]user functions available in the given catalog.

  Only system and user function descriptions matching the schema and function name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`.

  Each function description has the the following columns:

  1. FUNCTION_CAT String => function catalog (may be `null`)
  2. FUNCTION_SCHEM String => function schema (may be `null`)
  3. FUNCTION_NAME String => function name. This is the name used to invoke the function
  4. REMARKS String => explanatory comment on the function
  5. FUNCTION_TYPE short => kind of function:
     - functionResultUnknown - Cannot determine if a return value or table will be returned
     - functionNoTable- Does not return a table
     - functionReturnsTable - Returns a table
  6. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

  A user may not have permission to execute any of the functions that are returned by `getFunctions`

  Specified by:
    `getFunctions` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `functionNamePattern` - a function name pattern; must match the function name as it is stored in the database
  Returns:
    `ResultSet` - each row is a function description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9
  See Also:
    `getSearchStringEscape()`

### getFunctionColumns

    public ResultSet getFunctionColumns(String catalog,
                                        String schemaPattern,
                                        String functionNamePattern,
                                        String columnNamePattern)
                                 throws SQLException

  Retrieves a description of the given catalog's system or user function parameters and return type.

  Only descriptions matching the schema, function and parameter name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description, column description or return type description with the following fields:

  1. FUNCTION_CAT String => function catalog (may be `null`)
  2. FUNCTION_SCHEM String => function schema (may be `null`)
  3. FUNCTION_NAME String => function name. This is the name used to invoke the function
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - functionColumnUnknown - nobody knows
     - functionColumnIn - IN parameter
     - functionColumnInOut - INOUT parameter
     - functionColumnOut - OUT parameter
     - functionColumnReturn - function return value
     - functionColumnResult - Indicates that the parameter or column is a column in the `ResultSet`
  6. DATA_TYPE int => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale - null is returned for data types where SCALE is not applicable.
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL.
      - functionNoNulls - does not allow NULL values
      - functionNullable - allows NULL values
      - functionNullableUnknown - nullability unknown
  13. REMARKS String => comment describing column/parameter
  14. CHAR_OCTET_LENGTH int => the maximum length of binary and character based parameters or columns. For any other datatype the returned value is a NULL
  15. ORDINAL_POSITION int => the ordinal position, starting from 1, for the input and output parameters. A value of 0 is returned if this row describes the function's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1.
  16. IS_NULLABLE String => ISO rules are used to determine the nullability for a parameter or column.
      - YES --- if the parameter or column can include NULLs
      - NO --- if the parameter or column cannot include NULLs
      - empty string --- if the nullability for the parameter or column is unknown
  17. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

  The PRECISION column represents the specified column size for the given parameter or column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

  Specified by:
    `getFunctionColumns` in interface `DatabaseMetaData`
  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `functionNamePattern` - a procedure name pattern; must match the function name as it is stored in the database
    `columnNamePattern` - a parameter name pattern; must match the parameter or column name as it is stored in the database
  Returns:
    `ResultSet` - each row describes a user function parameter, column or return type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.6, HSQLDB 1.9
  See Also:
    `getSearchStringEscape()`

### unwrap

    public <T> T unwrap(Class<T> iface)
             throws SQLException

  Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. The result may be either the object found to implement the interface or a proxy for that object. If the receiver implements the interface then that is the object. If the receiver is a wrapper and the wrapped object implements the interface then that is the object. Otherwise the object is the result of calling `unwrap` recursively on the wrapped object. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

  Specified by:
    `unwrap` in interface `Wrapper`
  Parameters:
    `iface` - A Class defining an interface that the result must implement.
  Returns:
    an object that implements the interface. May be a proxy for the actual implementing object.
  Throws:
    `SQLException` - If no object found that implements the interface
  Since:
    JDK 1.6, HSQLDB 1.9

### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

  Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

  Specified by:
    `isWrapperFor` in interface `Wrapper`
  Parameters:
    `iface` - a Class defining an interface.
  Returns:
    true if this implements the interface or directly or indirectly wraps an object that does.
  Throws:
    `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
  Since:
    JDK 1.6, HSQLDB 1.9

### getPseudoColumns

    public ResultSet getPseudoColumns(String catalog,
                                      String schemaPattern,
                                      String tableNamePattern,
                                      String columnNamePattern)
                               throws SQLException

  Retrieves a description of the pseudo or hidden columns available in a given table within the specified catalog and schema. Pseudo or hidden columns may not always be stored within a table and are not visible in a ResultSet unless they are specified in the query's outermost SELECT list. Pseudo or hidden columns may not necessarily be able to be modified. If there are no pseudo or hidden columns, an empty ResultSet is returned.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by `TABLE_CAT`,`TABLE_SCHEM`, `TABLE_NAME` and `COLUMN_NAME`.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be `null`)
  2. TABLE_SCHEM String => table schema (may be `null`)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE int => SQL type from java.sql.Types
  6. COLUMN_SIZE int => column size.
  7. DECIMAL_DIGITS int => the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
  8. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  9. COLUMN_USAGE String => The allowed usage for the column. The value returned will correspond to the enum name returned by `PseudoColumnUsage.name()`
  10. REMARKS String => comment describing column (may be `null`)
  11. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  12. IS_NULLABLE String => ISO rules are used to determine the nullability for a column.
      - YES --- if the column can include NULLs
      - NO --- if the column cannot include NULLs
      - empty string --- if the nullability for the column is unknown

  The COLUMN_SIZE column specifies the column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

  Parameters:
    `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
    `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
    `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
    `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1
  See Also:
    `PseudoColumnUsage`

### generatedKeyAlwaysReturned

    public boolean generatedKeyAlwaysReturned()
                                       throws SQLException

  Retrieves whether a generated key will always be returned if the column name(s) or index(es) specified for the auto generated key column(s) are valid and the statement succeeds. The key that is returned may or may not be based on the column(s) for the auto generated key. Consult your JDBC driver documentation for additional details.

  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2013 HSQL Development Group.